Package com.evopdf

# Class HtmlToPdfVariableElement

java.lang.Object
com.evopdf.PageElement
com.evopdf.PageGraphicElement
com.evopdf.HtmlToPdfElement
com.evopdf.HtmlToPdfVariableElement

public class HtmlToPdfVariableElement extends HtmlToPdfElement
This class encapsulates a HTML to PDF converter functionality. Objects of this class can be added at any location in a `Template` to render HTML. A conversion is performed for each PDF page where the Template is rendered

- ## Field Summary

  ### Fields inherited from class com.evopdf.HtmlToPdfElement

  `AUTO_HTML_VIEWER_HEIGHT_PX, AUTO_PDF_HEIGHT_POINTS, AVAILABLE_PDF_WIDTH_POINTS, DEFAULT_HTML_VIEWER_WIDTH_PX`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `HtmlToPdfVariableElement(float x, float y, float width, float height, String htmlStringToConvert, String htmlStringBaseURL)`
  Creates a HTML string to PDF converter element at the specified x and y coordinates with the specified width and height using a base URL to resolve the external resources and a document URL to resolve the internal links
  `HtmlToPdfVariableElement(float x, float y, float width, float height, String htmlStringToConvert, String htmlStringBaseURL, int htmlViewerWidth, int htmlViewerHeight)`
  Creates a HTML string to PDF converter element at the specified x and y coordinates with the specified width and height using a base URL to resolve the external resources and a document URL to resolve the internal links.
  `HtmlToPdfVariableElement(float x, float y, float width, String htmlStringToConvert, String htmlStringBaseURL)`
  Creates a HTML string to PDF converter element at the specified x and y coordinates with the specified width using a base URL to resolve the external resources and a document URL to resolve the internal links.
  `HtmlToPdfVariableElement(float x, float y, float width, String htmlStringToConvert, String htmlStringBaseURL, int htmlViewerWidth)`
  Creates a HTML string to PDF converter element at the specified x and y coordinates with the specified width using a base URL to resolve the external resources and a document URL to resolve the internal links.
  `HtmlToPdfVariableElement(float x, float y, String htmlStringToConvert, String htmlStringBaseURL)`
  Creates a HTML string to PDF converter element at the specified x and y coordinates in PDF page using a base URL to resolve the external resources and a document URL to resolve the internal links.
  `HtmlToPdfVariableElement(String htmlStringToConvert, String htmlStringBaseURL)`
  Creates a HTML string to PDF converter element that will be rendered at the (0,0) location in PDF page using a base URL to resolve the external resources and a document URL to resolve the internal links.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `html()`
  Gets the variable HTML String to be converted to PDF
  `void`
  `setHtml(String html)`
  Sets the variable HTML String to be converted to PDF

  ### Methods inherited from class com.evopdf.HtmlToPdfElement

  `authenticationOptions, avoidHtmlElementsBreakSelectors, avoidImageBreak, avoidTextBreak, baseUrl, bottomSpacing, clipHtmlView, conversionDelay, defaultHtmlEncoding, downloadAllResources, embedFonts, enable3DTransformations, enableAccelerated2DCanvas, enableHttp2, enablePersistentStorage, enableWebGL, enhancedGraphicsQuality, extensionsEnabled, fitHeight, fitWidth, height, hiddenHtmlElementsSelectors, htmlDocumentInfo, htmlElementsMappingOptions, htmlViewerHeight, htmlViewerWidth, htmlViewerZoom, httpPostFields, httpRequestCookies, httpRequestHeaders, imagePartSize, imagesScalingEnabled, impersonationOptions, initialHtmlViewerHeight, insertNewPagesEnabled, interactiveHiddenElements, internalLinksEnabled, interruptSlowJavaScript, javaScriptEnabled, liveUrlsEnabled, localFilesAccessEnabled, manualTriggeringConversionDelay, maxHtmlViewerHeight, mediaType, minHtmlViewerHeight, navigationTimeout, navigatorUserAgent, noSizeElementsEnabled, pageBreakAfterHtmlElementsSelectors, pageBreakBeforeHtmlElementsSelectors, paginate, pdfBookmarkOptions, pdfFormOptions, persistentHttpRequestHeaders, postScriptFontsEnabled, prerenderEnabled, proxyOptions, renderedHtmlElementSelector, renderedPagesRectangles, setAvoidHtmlElementsBreakSelectors, setAvoidImageBreak, setAvoidTextBreak, setBaseUrl, setBottomSpacing, setClipHtmlView, setConversionDelay, setDefaultHtmlEncoding, setDownloadAllResources, setEmbedFonts, setEnable3DTransformations, setEnableAccelerated2DCanvas, setEnableHttp2, setEnablePersistentStorage, setEnableWebGL, setEnhancedGraphicsQuality, setExtensionsEnabled, setFitHeight, setFitWidth, setHeight, setHiddenHtmlElementsSelectors, setHtmlViewerHeight, setHtmlViewerWidth, setHtmlViewerZoom, setImagePartSize, setImagesScalingEnabled, setInitialHtmlViewerHeight, setInsertNewPagesEnabled, setInteractiveHiddenElements, setInternalLinksEnabled, setInterruptSlowJavaScript, setJavaScriptEnabled, setLiveUrlsEnabled, setLocalFilesAccessEnabled, setManualTriggeringConversionDelay, setMaxHtmlViewerHeight, setMediaType, setMinHtmlViewerHeight, setNavigationTimeout, setNavigatorUserAgent, setNoSizeElementsEnabled, setPageBreakAfterHtmlElementsSelectors, setPageBreakBeforeHtmlElementsSelectors, setPaginate, setPersistentHttpRequestHeaders, setPostScriptFontsEnabled, setPrerenderEnabled, setRenderedHtmlElementSelector, setShowFooterInEvenPages, setShowFooterInOddPages, setShowHeaderInEvenPages, setShowHeaderInOddPages, setStackRepeatedTableFooters, setStackRepeatedTableHeaders, setStretchToFit, setSvgFontsEnabled, setTableFooterRepeatEnabled, setTableHeaderRepeatEnabled, setTableOfContentsEnabled, setTopSpacing, setTransparentImagesEnabled, setTriggeringMode, setUrl, setWebFontsEnabled, setWidth, setX, setXPSupplementalLanguages, setY, showFooterInEvenPages, showFooterInOddPages, showHeaderInEvenPages, showHeaderInOddPages, stackRepeatedTableFooters, stackRepeatedTableHeaders, stretchToFit, svgFontsEnabled, tableFooterRepeatEnabled, tableHeaderRepeatEnabled, tableOfContentsEnabled, tiledRenderingEnabled, tiledRenderingEnabled, topSpacing, transparentImagesEnabled, triggeringMode, url, webFontsEnabled, width, x, xpSupplementalLanguages, y`

  ### Methods inherited from class com.evopdf.PageGraphicElement

  `backColor, blending, clipRectangle, foreColor, gradient, lineStyle, opacity, rotate, scale, setBackColor, setBlending, setClipRectangle, setForeColor, setGradient, setLineStyle, setOpacity, skew, translate`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### HtmlToPdfVariableElement

    public HtmlToPdfVariableElement(String htmlStringToConvert, String htmlStringBaseURL)
    Creates a HTML string to PDF converter element that will be rendered at the (0,0) location in PDF page using a base URL to resolve the external resources and a document URL to resolve the internal links. The width of element in PDF page is the available width in PDF page and the height is auto determined
    Parameters:
      `htmlStringToConvert` - The HTML string to convert to PDF
      `htmlStringBaseURL` - The full URL of the page from where this String was taken used to resolve the images and CSS files referenced by a relative URL in the HTML String. This parameter is optional and the default value is NULL

  - ### HtmlToPdfVariableElement

    public HtmlToPdfVariableElement(float x, float y, String htmlStringToConvert, String htmlStringBaseURL)
    Creates a HTML string to PDF converter element at the specified x and y coordinates in PDF page using a base URL to resolve the external resources and a document URL to resolve the internal links. The width of element in PDF page is the available width in PDF page and the height is auto determined
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `htmlStringToConvert` - the HTML string to convert to PDF
      `htmlStringBaseURL` - the full URL of the page from where this String was taken used to resolve the images and CSS files referenced by a relative URL in the HTML String. This parameter is optional and the default value is NULL. When this parameter is NULL no base URL will be used

  - ### HtmlToPdfVariableElement

    public HtmlToPdfVariableElement(float x, float y, float width, String htmlStringToConvert, String htmlStringBaseURL)
    Creates a HTML string to PDF converter element at the specified x and y coordinates with the specified width using a base URL to resolve the external resources and a document URL to resolve the internal links. The height in PDF is auto determined
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `width` - the destination width in points for the rendered content. If the specified with is less or equal 0, the destination width will be given by the available width in page
      `htmlStringToConvert` - the HTML string to convert to PDF
      `htmlStringBaseURL` - the full URL of the page from where this String was taken used to resolve the images and CSS files referenced by a relative URL in the HTML String. This parameter is optional and the default value is NULL. When this parameter is NULL no base URL will be used

  - ### HtmlToPdfVariableElement

    public HtmlToPdfVariableElement(float x, float y, float width, float height, String htmlStringToConvert, String htmlStringBaseURL)
    Creates a HTML string to PDF converter element at the specified x and y coordinates with the specified width and height using a base URL to resolve the external resources and a document URL to resolve the internal links
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `width` - the destination width in points for the rendered content. If the specified with is less or equal 0, the destination width will be given by the available width in page
      `height` - the destination height in points for the rendered content. If the specified height is less or equal 0, the destination height will be auto determined so all the content can be rendered. Please note that the specified height is the effective height that will be rendered in the PDF document and does not include for example the empty spaces introduced by custom or automatic page breaks
      `htmlStringToConvert` - the HTML string to convert to PDF
      `htmlStringBaseURL` - the full URL of the page from where this String was taken used to resolve the images and CSS files referenced by a relative URL in the HTML String. This parameter is optional and the default value is NULL. When this parameter is NULL no base URL will be used

  - ### HtmlToPdfVariableElement

    public HtmlToPdfVariableElement(float x, float y, float width, String htmlStringToConvert, String htmlStringBaseURL, int htmlViewerWidth)
    Creates a HTML string to PDF converter element at the specified x and y coordinates with the specified width using a base URL to resolve the external resources and a document URL to resolve the internal links. The height in PDF is auto determined. The virtual browser width in pixels is specified by the htmlViewerWidth parameter
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `width` - the destination width in points for the rendered content. If the specified with is less or equal 0, the destination width will be given by the available width in page
      `htmlStringToConvert` - the HTML string to convert to PDF
      `htmlStringBaseURL` - the full URL of the page from where this String was taken used to resolve the images and CSS files referenced by a relative URL in the HTML String. This parameter is optional and the default value is NULL. When this parameter is NULL no base URL will be used
      `htmlViewerWidth` - the virtual browser width in pixels. The default value is 1024 pixels. The effect of this parameter is similar with viewing the HTML page in a browser window with the specified width

  - ### HtmlToPdfVariableElement

    public HtmlToPdfVariableElement(float x, float y, float width, float height, String htmlStringToConvert, String htmlStringBaseURL, int htmlViewerWidth, int htmlViewerHeight)
    Creates a HTML string to PDF converter element at the specified x and y coordinates with the specified width and height using a base URL to resolve the external resources and a document URL to resolve the internal links. The virtual browser width and height in pixels is specified by the htmlViewerWidth and htmlViewerHeight parameters
    Parameters:
      `x` - the x position in points where the rendered content will be placed
      `y` - the y position in points where the rendered content will be placed
      `width` - the destination width in points for the rendered content. If the specified with is less or equal 0, the destination width will be given by the available width in page
      `height` - the destination height in points for the rendered content. If the specified height is less or equal 0, the destination height will be auto determined so all the content can be rendered. Please note that the specified height is the effective height that will be rendered in the PDF document and does not include for example the empty spaces introduced by custom or automatic page breaks
      `htmlStringToConvert` - the HTML string to convert to PDF
      `htmlStringBaseURL` - the full URL of the page from where this String was taken used to resolve the images and CSS files referenced by a relative URL in the HTML String. This parameter is optional and the default value is NULL. When this parameter is NULL no base URL will be used
      `htmlViewerWidth` - the virtual browser width in pixels. The default value is 1024 pixels. The effect of this parameter is similar with viewing the HTML page in a browser window with the specified width
      `htmlViewerHeight` - the virtual browser height in pixels. The default value is 0 which means the height will be auto-determined. The effect of this parameter is similar with viewing the HTML page in a browser window with the specified width and height. When this parameter is less or equal to 0, the converter will try to auto-determine the HTML page height from the HTML document content

- ## Method Details

  - ### html

    public String html()
    Gets the variable HTML String to be converted to PDF
    Overrides:
      `html` in class `HtmlToPdfElement`
    Returns:
      the HTML string to be converted to PDF

  - ### setHtml

    public void setHtml(String html)
    Sets the variable HTML String to be converted to PDF
    Overrides:
      `setHtml` in class `HtmlToPdfElement`
    Parameters:
      `html` - the HTML string to be converted to PDF